/* bldoftab.c */
/* returns 1 if error */

#include "sortmail.h"

OFD * oft_first, * oft_dups ;

int bldoftab(infile)
FILE * infile;
{
char * str ;
OFD * tmp_oft ;

fdebug(DBG_CALL,"BLDOFTAB(<%s)\n",cfd_ptr->filename);

if ( !infile ) return(1) ;

while ( ( str=getcfstr() ) != 0 ) {
	if ( regexec(re_FMT_OFT,str) ) oft_adds();
	else cfgerror("Format error:\n",0);
	}

if ( (tmp_oft=oft_find("ERRORS")) == NULL )
	if (ErrOutFile)
		tmp_oft=oft_add("ERRORS",ErrOutFile,
				"Corrupted messages & other errors");
	else cfgerror("\n\t\07'ErrOutFile' not found\n",1);
tmp_oft->flags |= OFFL_USE ;

if ( !oft_find("NOTSELECTED") )
	if (OtherOutFile)
		oft_add("NOTSELECTED",OtherOutFile,
			"Messages, not selected by any 'sel'");
	else cfgerror("\n\t\07'OtherOutFile' not found\n",1);

if ( !oft_find("NULL") ) (oft_add("NULL","NULL","NULLFILE"))->ofh=DUMMYFILE ;

#ifdef _USE_xDBM
if (CSDBFile) {
  if ( !oft_find("DUPS") ) {
	if ( DupsOutFile ) oft_dups=oft_add("DUPS",DupsOutFile,"DUPS");
	else {
		oft_dups=oft_add("DUPS","NULL","NULLFILE (DUPS)") ;
		oft_dups->ofh=DUMMYFILE ;
		}
	}
  oft_dups->flags |= OFFL_USE ;
  }
#endif /*xDBM*/

return(0);

}

/******/
OFD * oft_adds()
{
int i;
char * p1, * p2, * p3 ;
OFD * tmp_ofd ;

p1=stredup(	re_FMT_OFT->startp [ (*(_OFT_FldSeq+0)-'0')&15 ] ,
		re_FMT_OFT->endp   [ (*(_OFT_FldSeq+0)-'0')&15 ] ) ;
p2=stredup(	re_FMT_OFT->startp [ (*(_OFT_FldSeq+1)-'0')&15 ] ,
		re_FMT_OFT->endp   [ (*(_OFT_FldSeq+1)-'0')&15 ] ) ;
p3=stredup(	re_FMT_OFT->startp [ (*(_OFT_FldSeq+2)-'0')&15 ] ,
		re_FMT_OFT->endp   [ (*(_OFT_FldSeq+2)-'0')&15 ] ) ;

tmp_ofd=oft_add(p1,p2,p3) ;
free(p1); free(p2); free(p3);
return(tmp_ofd);
}

/* oft_find - find oft by outname */
OFD * oft_find(outname)
char *outname;
{
OFD * tofptr=oft_first ;
fdebug(DBG_CALL,"OFT_FIND('%s')\n",outname);
while (tofptr) {
	if ( !strcmp(outname,tofptr->outname) ) return(tofptr);
	tofptr=tofptr->next;
	}
return((OFD*)NULL);
}


/* oft_ins - include in chain */
void oft_ins(oft_ptr)
OFD * oft_ptr ;
{
oft_ptr->prev=NULL;
oft_ptr->next=oft_first;
if (oft_first) oft_first->prev=oft_ptr;
oft_first=oft_ptr;
}


/* oft_del - remove from chain */
void oft_del(oft_ptr)
OFD * oft_ptr ;
{
if (oft_ptr->next) /*=not last*/ (oft_ptr->next)->prev=oft_ptr->prev;
if (oft_ptr->prev) /*=not 1-st*/ (oft_ptr->prev)->next=oft_ptr->next;
else		   /*=1-st*/	 oft_first=oft_ptr->next;
oft_ptr->next=NULL;
oft_ptr->prev=NULL;
}


/* oft_free - remove from chain & free memory */
void oft_free(oft_ptr)
OFD * oft_ptr ;
{
fdebug(DBG_CALL,"OFT_FREE(=%s)\n",oft_ptr->outname);
oft_del(oft_ptr);
if ( oft_ptr->outname != oft_ptr->filename ) free(oft_ptr->outname) ;
if ( oft_ptr->comment != oft_ptr->filename ) free(oft_ptr->comment) ;
free( oft_ptr->filename ) ;
free(oft_ptr);
}


/* oft_add */
OFD * oft_add(outname,filename,comment)
char * outname, * filename, * comment ;
{
OFD * tofptr ;
fdebug(DBG_CALL,"OFT_ADD('%s','%s','%s')\n",outname,filename,comment);

if ( !filename || !strlen(filename) ) {
	cfgerror("FILENAME invalid\n",0);
	return(NULL);
	}

if ( ( tofptr=oft_find(outname) ) != 0 ) {
	cfgerror("OUTFILE already defined\n",0);
	seterror(ERROR_CONFIG);
	}

tofptr=smmalloc(sizeof(OFD));
tofptr->filename=strdup(filename) ;
tofptr->outname=( outname ? strdup(outname) : tofptr->filename ) ;
tofptr->comment=( comment ? strdup(comment) : tofptr->filename ) ;
tofptr->a_fname=tofptr->filename ; /*temporary*/
tofptr->ofh=NULL ;
tofptr->flags=0 ;
tofptr->usecnt=0 ;
oft_ins(tofptr);

if (*filename=='$'  &&  ( tofptr->a_fname=strdupz(getenv(filename+1)) )==0 )
	cfgerror("Environment variable not defined\n",1);

else if (*filename=='|') {
	tofptr->a_fname=NULL ; /*??? strdup(nonblank(filename+1));*/
	tofptr->flags |= OFFL_PIPE ;
	}

else if (
#ifdef MSDOS
	*filename != '\\'	&&	/* '\dir\...' */
	*(filename+1) != ':'	&&	/* 'c:\dir\...' */
#endif
	*filename != '.'  &&  *filename != '/' )
		tofptr->a_fname = strd3cat( OutputDir, cfd_ptr->fileprefix,
							tofptr->filename);

else	tofptr->a_fname=tofptr->filename ;

return(tofptr);

}

/*EOF bldoftab.c */
