/* bldretab.c */
#include "sortmail.h"

RE * re_origin;

int bldretab(infile)
FILE * infile;
{
char * str ;
char * p1, * p2 ;

fdebug(DBG_CALL,"BLDRETAB(<%s)\n",cfd_ptr->filename);

if ( !infile ) return(1) ;

while ( ( str=getcfstr() ) != 0 ) {
	if ( regexec(re_FMT_RET,str) ) {
		p1=stredup(re_FMT_RET->startp[1],re_FMT_RET->endp[1]) ;
		p2=stredup(re_FMT_RET->startp[2],re_FMT_RET->endp[2]) ;
		re_add(p1,p2);
		free(p1); free(p2);
		}
	else cfgerror("Format error :\n",0);
	}
return(0);
}


RE * re_add(name,text)
char * name, * text ;
{
RE * re_ptr;
regexp * tmpptr;
fdebug(DBG_CALL,"RE_ADD('%s','%s')\n",name,text);
if ( re_find(name) ) {
	cfgerror("Duplicate RE:\n",0);
	return(NULL);
	}

re_ptr=smmalloc(sizeof(RE));

if ( cfd_ptr->re_style == RE_STYLE_DOS ) {
	re_ptr->re_text=msubst(text,re_cvt_dos);
	fdebug(DBG_CVRE,"RE_DOS: '%s' -> '%s'\n",text,re_ptr->re_text);
	}
else if ( cfd_ptr->re_style == RE_STYLE_USER ) {
	re_ptr->re_text=msubst(text,re_cvt_user);
	fdebug(DBG_CVRE,"RE_USER: '%s' -> '%s'\n",text,re_ptr->re_text);
	}
else
	re_ptr->re_text=strdup(text);

re_ptr->re_name=( name ? strdup(name) : re_ptr->re_text ) ;
re_ptr->re_pgm=NULL; /*!*/
re_ptr->flags=0;
re_ptr->test_cnt=0;
re_ptr->match_cnt=0;

if ( ( tmpptr=regcomp(re_ptr->re_text) ) != 0 ) {
	free(tmpptr);
	re_ptr->next=re_origin;
	re_origin=re_ptr;
	return(re_ptr);
	}
else {
	cfgerror("Invalid RE:\n",0);
	return(NULL);
	}
}

RE * re_find(name)
char * name ;
{
RE * re_ptr;
fdebug(DBG_CALL,"RE_FIND('%s')\n",name);
if (name) for (re_ptr=re_origin;re_ptr;re_ptr=re_ptr->next)
	if ( !strcmp(re_ptr->re_name,name) ) return(re_ptr) ;
return(NULL);
}

/*EOF bldretab.c */
