/* bldsrttb.c */
/* returns 1 if error */

#include "sortmail.h"

typedef struct {
	char * keyword;
	int minlength;
	int opcode;
	} STMT_DSC;

static STMT_DSC stmtdtab[]=
{
{"{",		1,	OP_BBEGIN},
{"}",		1,	OP_BEND},
{"select",	1,	OP_SELECT},
{"eselect",	2,	OP_ESELECT},
{"exclude",	2,	OP_EXCLUDE},
{"eexclude",	2,	OP_EEXCLUDE},
{"out",		1,	OP_OUT},
{"dupout",	1,	OP_DUPOUT},
{NULL,		0,	0}
} ;

OP_TAB * opt_origin = NULL ;
OP_TAB * last_optp=NULL ;

HLPTR * hlp_first ;

int max_sel_level ;

static int c_level=0;

static void ** retptr;

int bldsrttb(infile)
FILE * infile;
{
char * instr, * tmpptr;
int stmtlen;
STMT_DSC * std_ptr;

fdebug(DBG_CALL,"BLDSRTTB(<%s)\n",cfd_ptr->filename);
if ( !infile ) return(1) ;

retptr=(void**)smmalloc(max_sel_level*sizeof(void*));

while ( ( instr=getcfstr() ) != 0 ) {
	if ( (tmpptr=strpbrk(instr," \t"))==NULL ) tmpptr=strchr(instr,'\0');
		stmtlen=(int)(tmpptr-instr);

	for (std_ptr=stmtdtab;std_ptr->keyword;std_ptr++) {
		if ( ( ( stmtlen >= std_ptr->minlength ) &&
			!strnicmp(instr,std_ptr->keyword,stmtlen) ) ) {
			add_stmt( std_ptr->opcode, tmpptr ) ;
			break ;
			}
		if ( !std_ptr->keyword ) cfgerror("Format error:\n",0);
	} /*for stmttab*/
} /*while !EOF*/

if (c_level) cfgerror("\n\t\07Unbalanced '{'\n",1);

add_stmt(OP_OUT,"NOTSELECTED");

return(0); /*DEBUG*/
}


void add_stmt(opcode,strptr)
int opcode;
char * strptr;
{
OP_TAB * opt_ptr;
char * par1, * par2 ;

opt_ptr=smmalloc(sizeof(OP_TAB));
opt_ptr->next=NULL;
opt_ptr->linenum=cfd_ptr->linenum;
opt_ptr->cfname=cfd_ptr->filename;
if (last_optp)	last_optp->next=opt_ptr;
else		opt_origin=opt_ptr ;
last_optp=opt_ptr;
opt_ptr->opcode=opcode;

switch ( opcode ) {

case OP_SELECT	:
case OP_ESELECT	:
case OP_EXCLUDE	:
case OP_EEXCLUDE:
	if ( (strptr=(nonblank(strptr)))==NULL ) {
		cfgerror("Format error:\n",0);
		break;
		}
	if (regexec(re_FMT1_sel,strptr)) {
		par1=stredup(re_FMT1_sel->startp[1], re_FMT1_sel->endp[1]) ;
		par2=stredup(re_FMT1_sel->startp[2], re_FMT1_sel->endp[2]) ;
		opt_ptr->par1=hlp_add(par1) ; free(par1) ;
		if ( ( opt_ptr->par2=re_find(par2) )==NULL ) {
			cfgerror("\07RE not found\n",0);
			break;
			}
		free(par2);
		}
	else if (regexec(re_FMT2_sel,strptr)) {
		par1=stredup(re_FMT2_sel->startp[1], re_FMT2_sel->endp[1]) ;
		par2=stredup(re_FMT2_sel->startp[2], re_FMT2_sel->endp[2]) ;
		opt_ptr->par1=hlp_add(par1) ; free(par1) ;
		opt_ptr->par2=re_add(NULL,par2) ; free(par2) ;
		}
	else { cfgerror("Format error:\n",0); break; }

	((RE*)opt_ptr->par2)->flags |= REFL_USE ;

	/* Compiling RE, if not yet */
	if ( !((RE*)opt_ptr->par2)->re_pgm ) {
		if ( EquCharsTab &&
			( (opcode==OP_SELECT) || (opcode==OP_EXCLUDE) ) )
			strtrans( ((RE*)opt_ptr->par2)->re_text );
		if ( ( ((RE*)opt_ptr->par2)->re_pgm=
			regcomp( ((RE*)opt_ptr->par2)->re_text ) )==NULL ) {
			cfgerror("Can't compile RE:\n",1);
			}
		}
	break;

case OP_OUT	:
case OP_DUPOUT	:
	if ( (strptr=(nonblank(strptr)))==NULL ) {
		cfgerror("Format error:\n",0);
		break;
		}
	if (regexec(re_FMT1_out,strptr)) {
		par1=stredup(re_FMT1_out->startp[1], re_FMT1_out->endp[1]) ;
		if ( ( opt_ptr->par1=oft_find(par1) ) == NULL ) {
		    cfgerror("\07OUTFILE not found\n",0);
			break;
			}
		free(par1);
		}
	else if (regexec(re_FMT2_out,strptr)) {
		par1=stredup(re_FMT2_out->startp[1], re_FMT2_out->endp[1]) ;
		opt_ptr->par1=oft_add(NULL,par1,NULL) ; free(par1) ;
		}
	else if (regexec(re_FMT_OFT,strptr))
		opt_ptr->par1=oft_adds() ;
	else { cfgerror("Format error:\n",0); break; }

	((OFD*)opt_ptr->par1)->flags|=OFFL_USE ;
	break;

case OP_BBEGIN	:
	*(retptr+c_level)=opt_ptr;
	if ( ++c_level > max_sel_level ) cfgerror("\n\t\07Too many '{'\n",1);
	break;

case OP_BEND	:
	if ( --c_level < 0 ) cfgerror("\n\t\07Too many '}'\n",1);
	last_optp=*(retptr+c_level) ;
	last_optp->par1=last_optp->next ;
	opt_ptr->next=last_optp;
	break;

	}

}

/* flp_find */
HLPTR * hlp_find(hdrlptr)
char * hdrlptr ;
{
HLPTR * hlp_ptr;
fdebug(DBG_CALL,"HLP_FIND('%s')\n",hdrlptr);
if ( !hdrlptr || *hdrlptr==' ' || *hdrlptr=='\t' ) return(NULL);
for (hlp_ptr=hlp_first;hlp_ptr;hlp_ptr=hlp_ptr->next)
    if ( !strnicmp(hdrlptr,hlp_ptr->name,hlp_ptr->namelen) ) return(hlp_ptr);
return(NULL);
}


/* hlp_add */
HLPTR * hlp_add(hdrlname)
char * hdrlname ;
{
HLPTR * hlp_ptr;
fdebug(DBG_CALL,"HLP_ADD('%s')\n",hdrlname);

for (hlp_ptr=hlp_first;hlp_ptr;hlp_ptr=hlp_ptr->next)
	if ( !stricmp(hdrlname,hlp_ptr->name) ) return(hlp_ptr) ;
hlp_ptr=(HLPTR*)malloc(sizeof(HLPTR));
hlp_ptr->next=hlp_first;
hlp_first=hlp_ptr;
hlp_ptr->name=strdup(hdrlname);
hlp_ptr->namelen=strlen(hdrlname);
hlp_ptr->dataptr=NULL;
hlp_ptr->tr_dataptr=NULL;
hlp_ptr->flags=0;
return(hlp_ptr);
}

/*EOF bldsrttb.c */
