/* msg_out.c */

#include "sortmail.h"

FILE * outfile ;

int msg_out(oft_ptr)
OFD * oft_ptr ;
{
HLPTR * hlp_ptr;
char * bptr=msgbuf;
Flag PrevBlank=0;

fdebug(DBG_CALL,"MSGOUT(outfile=%s)\n",oft_ptr->outname);
PRINT(PR_OUTFILE,(PrOutfileFmt,oft_ptr->comment));

if ( !smfopeno(oft_ptr) )
	if ( msgflush(0) ) exit(ERROR_FATAL) ;
outfile=oft_ptr->ofh ;

while ( bptr < endmsg ) {
	if ( ( bptr < msgtext ) && DelHeadLines &&
			( hlp_ptr=hlp_find(bptr) ) != NULL &&
			( hlp_ptr->flags & HLPF_DELETE ) )
		fdebug( DBG_HNDOUT, "OUT: SKIP '%s'\n",bptr) ;
	else {
		if ( del_blank_lines && PrevBlank && *bptr=='\0' )
			fdebug(DBG_HNDOUT,"OUT: SKIP blank line\n") ;
		else {
			if ( bptr < msgtext ) hdrl_out(bptr);
			else str_out(bptr);
			}
		if ( *bptr=='\0' ) FlagOn(PrevBlank) ;
		else FlagOff(PrevBlank) ;
		}
	bptr=strchr(bptr,'\0') ; bptr ++ ;
	}
/*** end of buffer reached ***/


if (!msg_in_buf) {
	if (!fl_suppout) fputs(bptr,oft_ptr->ofh) ; /*last line*/

	while ( fgets(msgbuf,(size_t)buffer_size,inputfile) ) {
		if ( start_of_message(msgbuf) ) break ;
		else {
			strtrunc(msgbuf);
			if ( del_blank_lines && PrevBlank && !strlen(msgbuf) )
				fdebug(DBG_HNDOUT,"OUT: SKIP blank line\n");
			else str_out(msgbuf);
			if ( !strlen(msgbuf) ) FlagOn(PrevBlank) ;
			else FlagOff(PrevBlank) ;
			}
		}
	}

if ( !PrevBlank && !fl_suppout ) fputc('\n',oft_ptr->ofh) ;

smcloseo(oft_ptr,close_out_mode);
return(0);
}


/* hdrl_out */
int hdrl_out(str)
char * str;
{
char * ptr, *ptr2, * ssrch, * esrch, * sos, * eol ;

if (fl_suppout) return(0);/*???*/

eol=strchr(str,'\0');

if ( ( eol-str <= outlinelen ) || !(strnicmp(str,"From ",5)) ) str_out(str) ;

else {
	sos=str;
	ssrch=strchr(str,':')+2 ;
	esrch=str+outlinelen;
	ptr2=NULL;
	do {
		/* search backward  '; ' | ';\t' | ' ' | '\t' */
		for (ptr=esrch;ptr>ssrch;ptr--) {
			if ( *ptr==' ' || *ptr=='\t' ) {
				if ( *(ptr-1)==';' ) break ;
				if ( !ptr2 ) ptr2=ptr ;
				}
			}
		if (  !( (ptr>ssrch) ? 1 : ((ptr=ptr2)!=NULL) )  )
			/* search forward ' ' | '\t' */
			ptr=strpbrk(esrch," \t");
		/* now ptr-> ' '|'\t', where we can insert '\n', or EOL */
		ptr2=NULL;
		if ( !ptr ) {
			str_out(sos) ;
			break ;
			}
		*ptr='\0' ;
		str_out(sos) ;
		ssrch=nonblank(ptr+1);
		sos=ssrch-1;
		*sos=' ';
		esrch=ssrch+outlinelen-1;
		if ( esrch > eol ) {
			str_out(sos);
			break;
			}
		} while ( ptr < eol ) ;
	}

return(0);
}


/* write 1 line 2 output file */
int str_out(str)
char * str;
{
fdebug(DBG_OUTPUT,"OUT: \'%s\'\n",str);
if ( !fl_suppout && ( outfile != DUMMYFILE ) ) {
	fputs(str,outfile) ;
	fputc('\n',outfile) ;
	}
return(0);
}
/*EOF msg_out.c */
