/* smanalyz.c */
#include "sortmail.h"

int smselect( HLPTR *, RE *, int );

static long dbg_analyze2=DBG_ANALYZE2 ;
static char * dbg_a2_start="" ;

int smanalyz()
{
OP_TAB * op=opt_origin ;

if ( debug_bits&DBG_ANALYZE ) { dbg_analyze2=DBG_ANALYZE2|HIGHBITOFLONG ;
				dbg_a2_start="\n\t" ; }

do {

	switch ( op->opcode ) {

	case OP_SELECT:
	case OP_ESELECT:
		fdebug(DBG_ANALYZE,"%s:%04d\tSELECT ",op->cfname,op->linenum);

			if ( !smselect(op->par1,op->par2,op->opcode) )
				if ( (op=op->next)==0 ) return(0) ;
			op=op->next ;
			break ;

	case OP_EXCLUDE:
	case OP_EEXCLUDE:
		fdebug(DBG_ANALYZE,"%s:%04d\tEXCLUDE ",op->cfname,op->linenum);

			if ( smselect(op->par1,op->par2,op->opcode) ) {
				while ( op->opcode != OP_BEND )
					if ( (op=op->next)==0 ) return(0);
				if ( (op=op->next)==0 ) return(0);
				}
			op=op->next;
			break;

	case OP_OUT:
	case OP_DUPOUT:
		fdebug(DBG_ANALYZE,"%s:%04d\tOUT %s\n",op->cfname,op->linenum,
				((OFD*)op->par1)->outname ) ;

			msg_out(op->par1);
			if ( op->opcode==OP_OUT ) return(1) ;
			op=op->next; /*else DUPOUT*/
			break;


	case OP_BBEGIN:
		fdebug(DBG_ANALYZE,"%s:%04d\t{\n",op->cfname,op->linenum);
			op=op->par1;
			break ;

	case OP_BEND:
		fdebug(DBG_ANALYZE,"%s:%04d\t}\n",op->cfname,op->linenum);
			if ( (op=op->next)==0 ) return(0);
			op=op->next;
			break;
		}

	} while ( op ) ;

return(0);
}

int smselect(hlp_ptr,re_ptr,opcode)
RE * re_ptr;
HLPTR * hlp_ptr;
int opcode;
{

fdebug(DBG_ANALYZE|HIGHBITOFLONG,"%s %s",hlp_ptr->name,re_ptr->re_name);

re_ptr->test_cnt++;

if ( hlp_ptr->dataptr ) {
	if ( EquCharsTab && ((opcode==OP_SELECT)||(opcode==OP_EXCLUDE)) ) {
		if ( ! hlp_ptr->tr_dataptr )
		       hlp_ptr->tr_dataptr=strtrans(strdup(hlp_ptr->dataptr));
		fdebug(dbg_analyze2,"%s'%s' ? '%s' ",dbg_a2_start,
			hlp_ptr->tr_dataptr, re_ptr->re_text);
		if ( regexec(re_ptr->re_pgm,hlp_ptr->tr_dataptr) ) {
			fdebug((DBG_ANALYZE|DBG_ANALYZE2|HIGHBITOFLONG)," - Y\n");
			re_ptr->match_cnt++;
			return(1);
			}
		}
	else {
		fdebug(dbg_analyze2,"%s'%s' ? '%s' ",dbg_a2_start,
			hlp_ptr->dataptr, re_ptr->re_text);
		if ( regexec(re_ptr->re_pgm,hlp_ptr->dataptr) ) {
			re_ptr->match_cnt++;
			fdebug((DBG_ANALYZE|DBG_ANALYZE2|HIGHBITOFLONG)," - Y\n");
			return(1);
			}
		}
	}
fdebug((DBG_ANALYZE|DBG_ANALYZE2|HIGHBITOFLONG)," - N\n");
return(0);
}

/*EOF smanalyz.c*/
