/* smconfig.c */

#include "sortmail.h"
#include "version.h"
#include "rdconfig.h"

#if defined(MSDOS) || defined(ISC) || defined(Linux)
#include <getopt.h>
#endif

#ifdef MSDOS
char *__progname; /*For getopt compatibility*/
#endif

long	debug_bits=0 ;

int	debug_pause=0,
	del_blank_lines=0, del_blank_chars=0, outlinelen=80,
	print_bits,
	close_out_mode=0,
	CSexpire=0, DupUpdateKey=0
	;

static	int	buffer_size_k=15;
unsigned long	buffer_size;

time_t starttime ;

static long
	* debug_bits_= &debug_bits
	;

static int
	* debug_pause_= &debug_pause,
	* del_blank_lines_= &del_blank_lines,
	* del_blank_chars_= &del_blank_chars,
	* buffer_size_k_= &buffer_size_k,
	* max_open_out_ = &max_open_out,
	* max_out_pipes_ = &max_out_pipes,
	* max_sel_level_ = &max_sel_level,
	* print_bits_ = &print_bits,
	* pipe_mode_ = &pipe_mode,
	* files_for_pipe_ = &files_for_pipe,
	* out_line_length_ = &outlinelen,
	* close_out_mode_ = &close_out_mode,
	* CSexpire_ = &CSexpire, * DupUpdateKey_ = &DupUpdateKey
	;

static char * CfgVersion = NULL,
	* RegisteredTo=NULL,
	* RegisterKey=NULL
	;

/*char LastOpenedFile[FILENAMELEN];*/

char	* InputFileName, * EquCharsTab, * SortDefsFile, * REDictFile,
	* REConvRules, * DebugOutFile,
	* OutputDir, * ErrOutFile, * OutFilesTab, * DelHeadLines,
	* OtherOutFile, * DupsOutFile,
	* CSDBFile, * CSCharSet,
	* PrintHeadLines, * RegExpStyle,
	* PrMsgNumFmt, * PrOutfileFmt, * PrHdrlineFmt,
	* _StartOfMessage,
	* _FMT_OFT,
	* _FMT1_sel, * _FMT2_sel, * _FMT1_out, * _FMT2_out,
	* _FMT_RET,
	* _OFT_FldSeq
	;

regexp
	* re_FMT1_sel, * re_FMT2_sel, * re_FMT1_out, * re_FMT2_out,
	* re_FMT_OFT, * re_FMT_RET,
	* re_StartOfMessage
	;

static SR fmtcvt[] = {
{&fmtcvt[1],	"\\\\",	"\\"},	/* two backslashes -> one */
{&fmtcvt[2],	"\\n",	"\n"},
{&fmtcvt[3],	"\\r",	"\r"},
{&fmtcvt[4],	"\\t",	"\t"},
{NULL,		"\\E",	"\033"}
} ;

HLPTR * hlp_From, * hlp_Subject ;


static PARDEF partbl[] = {
{"CfgVersion=",	   "%s",	        "'%s'\n", &CfgVersion,},
{"DebugBits=",	   "%d",	        "%d\n",	 (void*)&debug_bits_,},
{"DebugPause=",	   "%d",	        "%d\n",	 (void*)&debug_pause_,},
{"DebugOutFile=",  "%s",	        "'%s'\n", &DebugOutFile,},
{"DelBlankLines=", "%d",	        "%d\n",	 (void*)&del_blank_lines_,},
{"DelBlankChars=", "%d",	        "%d\n",	 (void*)&del_blank_chars_,},
{"OutLineLength=", "%d",	        "%d\n",	 (void*)&out_line_length_,},
{"MsgBufferSize=", "%d",	        "%d\n",	 (void*)&buffer_size_k_,},
{"MaxOpenOut=",	   "%d",	        "%d\n",	 (void*)&max_open_out_,},
{"PipeMode=",	   "%d",	        "%d\n",	 (void*)&pipe_mode_,},
{"MaxOutPipes=",   "%d",	        "%d\n",	 (void*)&max_out_pipes_,},
{"CloseOutMode=",  "%d",	        "%d\n",	 (void*)&close_out_mode_,},
{"FilesForPipe=",  "%d",	        "%d\n",	 (void*)&files_for_pipe_,},
{"MaxSelLevel=",   "%d",	        "%d\n",	 (void*)&max_sel_level_,},
{"InputFile=",	   "%s",	        "'%s'\n",&InputFileName,},
{"DelHeadLines=",  "%*[	\t']%[^']'",    "'%s'\n",&DelHeadLines,},
{"PrintBits=",	   "%d",	        "%d\n",	 (void*)&print_bits_,},
{"PrintHeadLines=","%*[	\t']%[^']'",    "'%s'\n",&PrintHeadLines,},
{"_PrMsgNumFmt=",  "%*[	\t']%[^']'",    "'%s'\n",&PrMsgNumFmt,},
{"_PrOutfileFmt=", "%*[	\t']%[^']'",    "'%s'\n",&PrOutfileFmt,},
{"_PrHdrlineFmt=", "%*[	\t']%[^']'",    "'%s'\n",&PrHdrlineFmt,},
{"EquCharsTab=",   "%s",	        "'%s'\n",&EquCharsTab,},
{"SortDefsFile=",  "%s",	        "'%s'\n",&SortDefsFile,},
{"REDictFile=",	   "%s",	        "'%s'\n",&REDictFile,},
{"REConvRules=",   "%s",	        "'%s'\n",&REConvRules,},
{"OutputDir=",	   "%s",	        "'%s'\n",&OutputDir,},
{"OutFilesTab=",   "%s",	        "'%s'\n",&OutFilesTab,},
{"ErrOutFile=",	   "%s",	        "'%s'\n",&ErrOutFile,},
{"OtherOutFile=",  "%s",	        "'%s'\n",&OtherOutFile,},
#ifdef _USE_xDBM
{"CSDBFile=",	   "%s",	        "'%s'\n",&CSDBFile,},
{"CSCharSet=",	   "%*[ \t\"]%[^\"]\"", "'%s'\n",&CSCharSet,},
{"CSexpire=",	   "%d",	        "%d\n",  (void*)&CSexpire_,},
{"DupsOutFile=",   "%s",	        "'%s'\n",&DupsOutFile,},
{"DupUpdateKey=",  "%d",	        "%d\n",  (void*)&DupUpdateKey_,},
#endif /*xDBM*/
{"RegExpStyle=",   "%s",	        "'%s'\n",&RegExpStyle,},
{"_RegisteredTo=", "%*[ \t\"]%[^\"]\"", "'%s'\n",&RegisteredTo},
{"_RegisterKey=",  "%s",	        "'%s'\n",&RegisterKey,},
{"_MsgFirstLine=", "%*[ \t\"]%[^\"]\"", "'%s'\n",&_StartOfMessage,},
{"_FMT_OFT=",	   "%*[	\t\"]%[^\"]\"",	"'%s'\n",&_FMT_OFT,},
{"_OFT_FldSeq=",   "%s",	        "'%s'\n",&_OFT_FldSeq,},
{"_FMT_RET=",	   "%*[	\t\"]%[^\"]\"",	"'%s'\n",&_FMT_RET,},
{"_FMT1_sel=",	   "%*[	\t\"]%[^\"]\"",	"'%s'\n",&_FMT1_sel,},
{"_FMT2_sel=",	   "%*[	\t\"]%[^\"]\"",	"'%s'\n",&_FMT2_sel,},
{"_FMT1_out=",	   "%*[	\t\"]%[^\"]\"",	"'%s'\n",&_FMT1_out,},
{"_FMT2_out=",	   "%*[	\t\"]%[^\"]\"",	"'%s'\n",&_FMT2_out,},
{NULL}
} ;

static char * UsageMsg="SortMail  V"VERSION"  ("__DATE__")\n"\
"Usage: %s\n"\
"	-C config_file\n"\
"	-i input_file\n"\
"	-p - print bits\n"\
"	-n - suppress actual output\n"\
"	-d - handle dups (doen't suppress dup warnings)\n"\
"	-D - do not store keys to database\n"\
"	-x - debugging bits 0-32768\n"\
"	-t - test mode = -n -D -x?? (Must be 1-st in command line)\n"\
	;

char * msgbuf, * endbuf, * msgtext, * endmsg, * workbuf ;

static char * config_file=NULL ;

Flag	msg_in_buf, hdr_in_buf;
Flag	fl_suppout=0, fl_hnddup=0, fl_nwkey=0 ;

FILE * dbgout=stderr ;

cf_dsc * cfd_ptr ;
int inclevel=0 ;
int default_re_style=RE_STYLE_RE ;

/****************************************************************************/
int smconfig(margc,margv)
int margc;
char * margv[1] ;
{

int c;
int rdconf_rc;
long opt_debug_bits=-1;
int opt_print_bits=-1;
char * opt_input_file=NULL ;
PARDEF * ptptr ;
OFD * oft_ptr ;
cf_dsc cftab[MAXINCLEVEL+1] ;
char * tmpstr;
HLPTR * hlp_ptr;
cfd_ptr = &cftab[0];
workbuf=(char*)smmalloc(WORKBUFSIZE) ;

#ifdef MSDOS
__progname=margv[0] ;
#endif /*MSDOS*/

time(&starttime) ;

while ( (c=getopt(margc,margv,
#ifdef _USE_xDBM
		"C:i:x:p:?ndDt"
#else
		"C:i:x:p:?nt"
#endif /*xDBM*/
				)) != EOF ) {
	switch(c) {
	case 'C':	config_file=strdup(optarg);
			break;
	case 'i':	opt_input_file=strdup(optarg);
			break;
	case 'p':	opt_print_bits=atoi(optarg);
			print_bits=opt_print_bits;
			break;
	case 'x':	debug_bits=atol(optarg);
			opt_debug_bits=debug_bits;
			printf("Debug bits=%d\n",debug_bits); break;
	case 'n':	printf("Output suppressed\n");
			FlagOn(fl_suppout); break;
	case 't':	printf("Test mode\n");
			FlagOn(fl_suppout);FlagOn(fl_nwkey);
			break;
#ifdef _USE_xDBM
	case 'd':	FlagOn(fl_hnddup); break;
	case 'D':	FlagOn(fl_nwkey); break;
#endif /*xDBM*/
	default:	seterror(ERROR_CONFIG);
	case '?':	printf(UsageMsg,margv[0]); exit(retcode);
		}
	}

if ( !config_file )
	if ( (config_file=getenv("SORTMAILCFG"))==NULL )
		config_file=CONFIGFILE ;

if ( !(smfcopen(config_file)) ) exit(ERROR_CONFIG) ;

PRINT(PR_STAGE,("Reading configuration...\n"));
if ( ( rdconf_rc=rdconfig(partbl,cfd_ptr->file) ) == 0 ) {
	cfgerror("\07No any options found\n",1) ;
	}

if ( strcmp(VERSION,CfgVersion) ) { fprintf(stderr,
	"*** Sortmail version="VERSION", conf.file version=%s\n",CfgVersion);
	exit(ERROR_CONFIG);
	}

if ( RegisteredTo ) {
	if (!RegisterKey) cfgerror("\007 Invalid '_RegisteredTo'\n",1);
	else printf("SortMail "VERSION", Registered To %s\n",RegisteredTo);
	}
else printf("SortMail "VERSION" - UNREGISTERED\n");

if (opt_debug_bits != -1 ) debug_bits=opt_debug_bits; /* '-x#' overwrites */
if (opt_print_bits != -1 ) print_bits=opt_print_bits; /* '-p#' overwrites */
if (opt_input_file) InputFileName=opt_input_file; /* -iFile overwrites */

if (debug_bits && DebugOutFile) dbgout=fopen(DebugOutFile,"a");
if (debug_bits && dbgout)
	fprintf(stderr,"Debugging output redirected to %s\n",DebugOutFile);
if (!dbgout) dbgout=stderr;

if (DBG_OPTIONS&debug_bits) {
/* Print config.*/
	fprintf(dbgout,"\tCONFIG FILE=%s; %d options read\n",config_file,rdconf_rc);
	ptptr = partbl /*&(PARTAB.par1)*/ ;
	while ( ptptr->parname != NULL ) {
		if ( *(ptptr->parname) != '_' ) /*Don't print '_..'*/ {
			fprintf(dbgout,"%s\t",ptptr->parname);
			if ( ptptr->printfmt[1]=='d' ) {
				fprintf(dbgout,ptptr->printfmt,*(int*)*ptptr->parvptr) ;
				}
			else
				fprintf(dbgout,ptptr->printfmt,*ptptr->parvptr);
			}
		ptptr++;
		} ;
	fprintf(dbgout,"\n");
	}

/* Adjust parameters */
#ifdef MSDOS
if ( buffer_size_k > 63 || buffer_size_k < 0 ) buffer_size_k=63 ;
#endif
buffer_size=buffer_size_k; buffer_size=(buffer_size << 10) ;
if ( debug_bits & DBG_NOOUT ) FlagOn(fl_suppout) ;

if ( (pipe_mode<0) || (pipe_mode>MAXPIPEMODE) ) pipe_mode = DEFAULTPIPEMODE;
if ( (close_out_mode<0) || (close_out_mode>2) ) close_out_mode=CLOSE_AT_END ;

if ( RegExpStyle ) {
	if (!strcmp(RegExpStyle,"REGEXP")) default_re_style=RE_STYLE_RE ;
	else if (!strcmp(RegExpStyle,"MSDOS")) default_re_style=RE_STYLE_DOS;
	else if (!strcmp(RegExpStyle,"USER")) default_re_style=RE_STYLE_USER;
	else cfgerror("Invalid 'RegExpStyle'\n",1);
	}

#define CHECK_RE(nm) if ( !(nm) || (re##nm=regcomp(nm))==NULL ) {\
	fprintf(stderr,"\n\t\07INVALID %s\n",#nm); cfgerror(NULL,1);}

CHECK_RE(_StartOfMessage)
CHECK_RE(_FMT1_sel)
CHECK_RE(_FMT2_sel)
CHECK_RE(_FMT1_out)
CHECK_RE(_FMT2_out)

if ( REDictFile ) CHECK_RE(_FMT_RET)

if ( OutFilesTab ) {
	CHECK_RE(_FMT_OFT)
	if ( !_OFT_FldSeq || (strlen(_OFT_FldSeq)!=3) ) {
	    cfgerror("\n\t\07_OFT_FldSeq ERROR!.\n",1);
	    }
	}

if ( !debug_bits ) debug_pause=0 ;

hlp_From=hlp_add("From:");
hlp_Subject=hlp_add("Subject:");

if ( PrintHeadLines ) {
	if ( (tmpstr=strtok(nonblank(PrintHeadLines)," \t")) != NULL ) {
		hlp_ptr=hlp_add(tmpstr);
		hlp_ptr->flags |= HLPF_PRINT ;
		while ( (tmpstr=strtok(NULL," \t")) != NULL ) {
			hlp_ptr=hlp_add(tmpstr);
			hlp_ptr->flags |= HLPF_PRINT ;
			}
		}
	}

if ( DelHeadLines ) {
	if ( ( tmpstr=strtok(nonblank(DelHeadLines)," \t") ) != NULL ) {
		hlp_ptr=hlp_add(tmpstr);
		hlp_ptr->flags |= HLPF_DELETE ;
		while ( (tmpstr=strtok(NULL," \t")) != NULL ) {
			hlp_ptr=hlp_add(tmpstr);
			hlp_ptr->flags |= HLPF_DELETE ;
			}
		}
	}

if ( PrMsgNumFmt ) PrMsgNumFmt=msubst(PrMsgNumFmt,fmtcvt);
else cfgerror("Invalid PrMsgNumFmt\n",1);
if ( PrOutfileFmt ) PrOutfileFmt=msubst(PrOutfileFmt,fmtcvt);
else cfgerror("Invalid PrOutfileFmt\n",1);
if ( PrintHeadLines&&PrHdrlineFmt ) PrHdrlineFmt=msubst(PrHdrlineFmt,fmtcvt);
else cfgerror("Invalid PrHdrlineFmt\n",1);

/* Other config.files */
PRINT(PR_STAGE,("Building control tables...\n"));

if ( EquCharsTab && bldtrtab(smfopen(EquCharsTab,"r")) ) exit(ERROR_CONFIG);

if ( REConvRules && bldrecvt(smfopen(REConvRules,"r")) ) exit(ERROR_CONFIG);

if ( OutFilesTab && bldoftab(smfcopen(OutFilesTab)) ) exit(ERROR_CONFIG);

if ( REDictFile && bldretab(smfcopen(REDictFile)) ) exit(ERROR_CONFIG);

if ( bldsrttb(smfcopen(SortDefsFile)) ) exit(ERROR_CONFIG);

for (oft_ptr=oft_first;oft_ptr;) {
	if ( !(oft_ptr->flags&OFFL_USE) ) {
		if (oft_ptr->next) {
			oft_ptr=oft_ptr->next;
			oft_free(oft_ptr->prev);
			}
		else {
			oft_free(oft_ptr);
			break;
			}
		}
	else
		oft_ptr=oft_ptr->next;
	}

return(0);

}

void cfgerror(string,exitnow)
char * string;
int exitnow;
{
if ( string ) fprintf(stderr,"*** %s",string);
fprintf(stderr,"File: %s , line %d :\n",cfd_ptr->filename,cfd_ptr->linenum);
if ( cfd_ptr->linenum != 0 ) fprintf(stderr,"%s\n\n",workbuf);
if (exitnow) exit(ERROR_CONFIG);
sleep(1);
seterror(ERROR_CONFIG);
}

/*EOF smconfig.c*/
