#if defined(MSDOS) || defined(__MSDOS__)
#include <io.h>
#endif

#ifdef __MSDOS__
#include <dir.h>
#endif

#include "sortmail.h"
#include <errno.h>

int max_open_out, max_out_pipes, files_for_pipe ;
int pipe_mode=0;

static int opened_out=0, opened_pipes=0 ;

FILE * smfopen(filename,mode)
char * filename;
char * mode;
{
FILE * fff;
char newname[FILENAMELEN];
char * tmpptr=NULL ;

if ( *filename == '$' ) {
	if ( ( tmpptr=getenv(filename+1) ) != 0 )	{
		strcpy(newname,tmpptr);
		fdebug(DBG_OPEN,"OPEN: using environment variable '%s'='%s'\n",
				filename+1, tmpptr ) ;
		}
	else { fprintf(stderr,"%s: environmet variable '%s' not found\n",
			__progname, filename+1 );	return(NULL);	} ;
	}
else
	strcpy(newname,filename) ;

fdebug(DBG_OPEN,"OPEN \'%s\',\'%s\'\n",newname,mode) ;
if ( (fff=fopen(newname,mode)) != 0 ) {
/*	strcpy(LastOpenedFile,newname) ;*/
	return fff;
	}
fdebug(DBG_OPEN,"\t- FAIL - %d !\n",errno) ;

strcpy(newname,__progname);
if ( !strchr(filename,'/') && !strchr(filename,'\\') &&
	( ( (tmpptr=strrchr(newname,'\\')) != 0 ) ||
	  ( (tmpptr=strrchr(newname,'/' )) != 0 ) ) )
		{
printf("3\n");fflush(stdout);
	strcpy(tmpptr+1,filename);
	fdebug(DBG_OPEN,"OPEN - TRY \'%s\',\'%s\'\n",newname,mode) ;
fflush(stdout);
	fff = fopen(newname,mode);
	if ( fff != NULL ) {
/*		strcpy(LastOpenedFile,newname) ;*/
		return(fff);
		}
	fdebug(DBG_OPEN,"\t- FAIL !\n") ;
	}

sprintf(newname,"%s: Cannot open '%s'",__progname,filename);
perror(newname);
return(NULL);
}


/* smfcopen - open configuration file */
FILE * smfcopen(filename)
char * filename ;
{
cfd_ptr->filename=strdupz(filename);
cfd_ptr->linenum=0;
cfd_ptr->file=smfopen(cfd_ptr->filename,"r");
cfd_ptr->fileprefix=NULL;
cfd_ptr->re_style=default_re_style;
return( cfd_ptr->file );
}


/* smfopeno - open output file */
FILE * smfopeno(oft_ptr)
OFD * oft_ptr;
{
char tmpbuf[512]; /*!!!*/
int saved_errno;

if ( oft_ptr != oft_first ) { oft_del(oft_ptr); oft_ins(oft_ptr);}/*=make 1-st*/
oft_ptr->usecnt++; /* inc. use counter */
if (oft_ptr->ofh) return(oft_ptr->ofh);

fdebug(DBG_OPEN,"SMFOPENO(%s='%s'='%s')\n",
	oft_ptr->outname,oft_ptr->filename,oft_ptr->a_fname);

if ( oft_ptr->flags & OFFL_PIPE ) {
#ifndef MSDOS
	if ( pipe_mode & PIPEM_PIPE ) return( smpopen(oft_ptr) );
#endif
	if ( !oft_ptr->a_fname ) {
		oft_ptr->a_fname=strdup("smtmpXXXXXX");/*?*/
		if ( !mktemp(oft_ptr->a_fname) ) {
			printf("MKTEMP ERROR?\n");
			exit(ERROR_FATAL);
			}
		}
	}

if ( opened_out >= max_open_out ) closeany();

if ( (oft_ptr->ofh=(fl_suppout? DUMMYFILE :
				fopen(oft_ptr->a_fname,"a") ) ) != NULL ) {
	opened_out++;
	fdebug(DBG_OPEN,"\t(%d outfiles opened)\n",opened_out);
	return(oft_ptr->ofh);
	}

saved_errno=errno;
printf("errno=%d\n",saved_errno);
if ( errno == EMFILE  &&  max_open_out > opened_out ) {
	max_open_out=opened_out;
	fprintf(stderr,"MaxOpenOut decreased to %d\n",max_open_out);
	closeany();
	return(smfopeno(oft_ptr)); /*!!! recursive call */
	}

sprintf(tmpbuf,"%s: Cannot open '%s'",__progname,oft_ptr->a_fname);
perror(tmpbuf);
return(NULL);

}


/* close ... */
void smcloseo(oft_ptr,p_close_mode)
OFD * oft_ptr;
int p_close_mode;
{
fdebug(DBG_OPEN,"SMCLOSEO(%s='%s')\n",oft_ptr->outname,oft_ptr->filename);
if ( !(oft_ptr->ofh) ||
	( (oft_ptr->ofh == DUMMYFILE) && !strcmp(oft_ptr->outname,"NULL") ) )
	return;

if ( oft_ptr->flags&OFFL_PIPE &&
	( p_close_mode==CLOSE_NOW || pipe_mode&PIPEM_1 ) ) {
	smclosep(oft_ptr); return;
	} /*<!???!>*/

if ( (p_close_mode == CLOSE_FFLUSH) && (oft_ptr->ofh != DUMMYFILE) )
	fflush(oft_ptr->ofh) ;

if ( p_close_mode == CLOSE_NOW ) {
	fdebug(DBG_OPEN,"FCLOSE('%s')\n",oft_ptr->filename);
	if (oft_ptr->ofh != DUMMYFILE) fclose(oft_ptr->ofh);
	oft_ptr->ofh=NULL;
	opened_out--;
	}
}


/* smclosep - close output pipe */
void smclosep(oft_ptr)
OFD * oft_ptr;
{
int oldstdin;
FILE * newin;
char * tmp;

#ifndef MSDOS
if ( pipe_mode & PIPEM_PIPE ) {
	pclose(oft_ptr->ofh);
	opened_pipes--;
	return;
	}
#endif

/*else = TMP file*/
fclose(oft_ptr->ofh);
opened_out--;
oft_ptr->ofh=NULL;

while ( max_open_out-opened_out < files_for_pipe ) {
	closeany();
	if ( !opened_out ) break;
	}

if ( (oldstdin=dup(0)) == -1 ) {/*?*/ return;}
newin=fopen(oft_ptr->a_fname,"r");
if ( ( dup2(fileno(newin),0) ) == -1 ) {/*?*/ return;}

tmp=nonblank( oft_ptr->filename + 1 ) ;
printf("SYSTEM('%s')\n",tmp);
system(tmp);

fclose(newin);
dup2(oldstdin,0);

if ( remove(oft_ptr->a_fname) ) {
	printf("REVOVE ERROR?\n");
	}

return;
}


/* closeany - close any output file */
void closeany()
{
OFD * oft_ptr;

fdebug(DBG_OPEN,"CLOSEANY()\n");
for (oft_ptr=oft_first; oft_ptr->next; oft_ptr=oft_ptr->next);/*last*/

for (;oft_ptr;oft_ptr=oft_ptr->prev) {
	if (  oft_ptr->ofh &&
	  !( (oft_ptr->ofh==DUMMYFILE) && !strcmp(oft_ptr->outname,"NULL") ) &&
	  !( (oft_ptr->flags&OFFL_PIPE) && (pipe_mode&PIPEM_PIPE) )  )
		break ;
	}
if ( !oft_ptr ) return; /*nothing to close...*/
smcloseo(oft_ptr,CLOSE_NOW);
}

#ifndef MSDOS
/* smpopen */
FILE * smpopen(oft_ptr)
OFD * oft_ptr;
{
/*maxpipes?*/
while ( max_open_out-opened_out < files_for_pipe * opened_pipes ) {
	closeany();
	if ( !opened_out ) break;
	}

if ( !oft_ptr->a_fname )
	oft_ptr->a_fname=nonblank(oft_ptr->filename+1) ;

if ( (oft_ptr->ofh=popen(oft_ptr->a_fname,"w")) != NULL ) {
	opened_pipes++;
	return(oft_ptr->ofh);
	}
sprintf(workbuf,"%s: Cannot open pipe '%s'",__progname,oft_ptr->a_fname);
perror(workbuf);
return(NULL);
}
#endif /*!MSDOS*/

/*EOF smfopen.c*/
