/* smfunct.c */
#include "sortmail.h"

void * smmalloc(size)
size_t size;
{
long psize;
void * ptr=malloc(size);
if ( !ptr ) {
	psize=size;
	fprintf(stderr,"\n\t\07MALLOC(%ld) ERROR, aborting\n",psize);
	exit(ERROR_FATAL);
	}
return(ptr);
}


char * hdrlfind(hdrlname)
char * hdrlname;
{
char * cbptr;

cbptr=msgbuf;
while ( cbptr < msgtext ) {
	if ( !(strnicmp(hdrlname,cbptr,strlen(hdrlname)) ) )
		return( nonblank( cbptr+strlen(hdrlname) ) );
	cbptr=strchr(cbptr,'\0') ; cbptr ++ ;
	}
return(NULL);
}

/* strtrans */
char * strtrans(str)
char *str;
{
char * strp=str ;
register unsigned char c ;
while ( ( c=*(strp) ) != 0 ) { c=trtab[c] ; if ( c ) *(strp++)=c ; }
return(str);
}

short csumm(startp,endp)
char * startp, * endp;
{
register unsigned char c, * p = (unsigned char *)startp ;
register unsigned long s=0;
unsigned short s2;

if ( endp==NULL ) endp=startp+strlen(startp) ; /* ?? opt ?? */

while ( p < (unsigned char *)endp ) {
	c=*(p++) ;
	s+=cstrtab[c] ;
	}

s2=( s & 0xffff ) + ( s >> 16 );
return( (short)( ( s2 & 0xffff ) + ( s2 >> 16 ) ) ) ;
}

/**/
void fdebug(/*va_alist*/
unsigned long test_bits,
char *fmt, ...
)
/*va_dcl*/
{
va_list	args;
/*
unsigned long test_bits;
char *fmt;
*/
int i;
unsigned char c ;

va_start(args,fmt/*?*/);
/*test_bits=va_arg(args, unsigned long);*/

if ( !( test_bits & debug_bits) ) return ;

if ( !( test_bits & HIGHBITOFLONG ) ) {
	for (i=0;i<26;i++) if ( test_bits & (long)1<<i ) break ;
	c='a'+i;
	fprintf(dbgout,"%c:",c);
	}

/*fmt=va_arg(args, char*);*/
vfprintf(dbgout,fmt,args);
fflush(dbgout);
va_end(args);
return;
}


#ifdef _USE_xDBM

#if   defined(USE_DBM)
int xdb_file;
#elif defined(USE_NDBM)
DBM * xdb_file;
#elif defined(USE_GDBM)
GDBM_FILE xdb_file;
#endif

static long nkey=0, ndeleted=0 ;

void dbexpire()
{
/*#ifdef USE_GDBM*/
datum xdb_prevkey;
/*#endif*/ /*USE_GDBM*/

datum dbm_key, dbm_data ;
int fl_first ;
#ifdef USE_GDBM
extern gdbm_error gdbm_errno ;
#endif /*GDBM*/

fdebug(DBG_CALL,"DBEXPIRE('%s')\n",CSDBFile);

if ( !CSDBFile ) return;
xdb_file=xdb_open(CSDBFile);
if ( !xdb_file ) fprintf(stderr,"Can't open %s\n",CSDBFile);
/* NEW ? */

if (fl_nwkey) return; /*?*/

PRINT(PR_STAGE,("CS database expire ...\n"));

fl_first=1;
dbm_key=xdb_firstkey() ;
while ( dbm_key.dptr ) {
	nkey++;
	if ( (nkey/10)*10==nkey ) {
		PRINT(PR_STAGE,("%ld\r",nkey)); fflush(stdout); /*?*/
		}
	dbm_data=xdb_fetch(dbm_key);

#ifdef USE_GDBM
	if (gdbm_errno) printf("FETCH ERROR: %d\n",gdbm_errno);
#endif /*GDBM*/

	fdebug(DBG_EXPIRE,"%8ld: F:%5hd S:%5hd T:%6hd  ",
		nkey,
		((CSDB_KEY*)dbm_key.dptr)->s_From,
		((CSDB_KEY*)dbm_key.dptr)->s_Subject,
		((CSDB_KEY*)dbm_key.dptr)->s_TEXT       ) ;

	if ( ((CSDB_DATA*)dbm_data.dptr)->expire < starttime ) {
	fdebug(DBG_EXPIRE|HIGHBITOFLONG,"EXPIRED\n");
		if ( xdb_delete(dbm_key) ) {

#ifdef USE_GDBM
			printf("DELETE ERROR: %d\n",gdbm_errno);
#endif /*GDBM*/
			; }
		else {
			ndeleted++;
			}
		/*sleep(1);*/
		free(dbm_key.dptr);
		}
	else {
		fdebug(DBG_EXPIRE|HIGHBITOFLONG,"expires  %s",
	  asctime( localtime( &((CSDB_DATA*)dbm_data.dptr)->expire ) )  ) ;

		if ( ! fl_first ) free(xdb_prevkey.dptr);
		fl_first=0 ;
		xdb_prevkey=dbm_key ;
		}
	free(dbm_data.dptr);
	if ( fl_first )	dbm_key=xdb_firstkey();
	else dbm_key=xdb_nextkey();
#ifdef USE_GDBM
	if (gdbm_errno) printf("NEXT/FIRST ERROR: %d\n",gdbm_errno);
#endif /*GDBM*/
	}


PRINT(PR_STAGE,("\t%ld keys,  %ld expired,  %ld left\n",
			nkey,ndeleted,nkey-ndeleted));
}
#endif /*xDBM*/


/* MSC library has no sleep() - use from BC library */
#ifdef MSC

#include <dos.h>
#define	time	dostime_t
#define	ti_hund	hsecond
#define	ti_sec	second
#define gettime	_dos_gettime

#include "sleep.c"

#endif

/*EOF smfunct.c */
