/* sortmail.h - global parameters, includes, etc */

#if defined(MSDOS) && !defined(__MSDOS__)
/*???*/
#define MSC
#endif

#if !defined(MSDOS) && defined(__MSDOS__)
#define MSDOS
#endif

#if defined(USE_DBM) || defined(USE_NDBM) || defined(USE_GDBM)
#define _USE_xDBM
#endif

/* Check MODEL */
#if ( defined(MSC) && !defined(M_I86LM) && !defined(M_I86HM) ) ||\
	( defined(__TURBOC__) && !defined(__LARGE__) && !defined(__HUGE__) )
#error LARGE or HUGE model must be used.
#endif

/********************* includes **********************/
/* local parameters */
#include "smlocals.h"

#ifdef MSDOS
#define DIRSEPCHAR '\\'
#else
#define DIRSEPCHAR '/'
#endif

/* system includes */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>

#if   defined(USE_DBM)
#include <dbm.h>
#elif defined(USE_NDBM)
#include <ndbm.h>
#elif defined(USE_GDBM)
#include <gdbm.h>
#endif

#ifdef _USE_xDBM
#include "x_dbm.h"
#if defined(MSDOS)
#include <fcntl.h>
#elif defined(__FreeBSD__)
#include <sys/fcntl.h>
#endif
#endif /*xDBM*/

#ifdef __STDC__
#include "regexp.h"
#else
#define __STDC__
#include "regexp.h"
#undef __STDC__
#endif /*__STDC__*/

#define DEBUG fprintf(stdout,"DEBUG:\t%s:\t%d\n",__FILE__,__LINE__);fflush(stdout);

/* exit error codes */
#define ERROR_CONFIG 4
#define ERROR_FATAL  2
#define ERROR_NOTFAT 1

typedef short int Flag;
#define	FlagOn(flagname)	flagname=1
#define	FlagOff(flagname)	flagname=0

typedef struct _any_chain {
	struct _any_chain *next;
	} ANY_CHAIN ;

typedef struct _sr_struct {
	struct _sr_struct *next;
	char *search;
	char *replace;
	} SR ;

typedef	struct _outfile {
	struct _outfile *next ;
	struct _outfile *prev ;
	char * outname ;
	char * comment ;
	char * filename ;
	char * a_fname ;
	FILE * ofh ;
	int flags ;
#define OFFL_PIPE	1
#define OFFL_USE	2
	int usecnt;
	}
	OFD ;

#define DUMMYFILE (FILE*)(-1)

typedef struct _re {
	struct _re * next;
	char * re_name;
	char * re_text;
	regexp * re_pgm;
	int flags;
#define	REFL_USE	1
	int test_cnt;
	int match_cnt;
	}
	RE ;

typedef struct _op_tab {
	struct _op_tab * next;
	int opcode;
#define	OP_SELECT	2
#define	OP_ESELECT	3
#define	OP_EXCLUDE	4
#define	OP_EEXCLUDE	5
#define	OP_BBEGIN	10
#define	OP_BEND		11
#define	OP_OUT		12
#define	OP_DUPOUT	13
	void * par1;
	void * par2;
	int linenum;
	char * cfname;
	} OP_TAB ;

typedef struct {
	char * filename;
	FILE * file;
	int linenum;
	int re_style;
	char * fileprefix;
	} cf_dsc;

typedef struct _hlptr {
	struct _hlptr * next;
	char * name;
	size_t namelen;
	char * lineptr;
	char * dataptr;
	char * tr_dataptr;
	int flags;
#define	HLPF_PRINT	1
#define	HLPF_DELETE	2
	} HLPTR ;

#ifdef _USE_xDBM
typedef struct {
	time_t expire ;
	} CSDB_DATA ;

typedef struct {
	unsigned short s_From, s_TEXT, s_Subject ;
	} CSDB_KEY ;
#endif /*xDBM*/


/*#define debug(bit,printparm) {if(bit&debug_bits) {printf printparm;fflush(stdout);}}*/
/*#define debug(bit,printparm) {if(bit&debug_bits) {fdebug printparm;}*/
#define PRINT(bit,printparm) {if(bit&print_bits) printf printparm;}

#define HIGHBITOFINT	0x8000
#define HIGHBITOFLONG	0x80000000
#define MAXINT		(int)0x7fff

#define DBG_ANALYZE	1<<('a'-'a')
#define DBG_ANALYZE2	1<<('b'-'a')
#define DBG_CALL	1<<('c'-'a')
/*			1<<('d'-'a')*/
#define DBG_EXPIRE	1<<('e'-'a')
#define DBG_OPEN	1<<('f'-'a')
/*			1<<('a'-'a')*/
#define DBG_HNDHDR	1<<('h'-'a')
#define DBG_INPUT	1<<('i'-'a')
#define DBG_HNDINP	1<<('j'-'a')
/*			1<<('k'-'a')*/
/*			1<<('l'-'a')*/
/*			1<<('m'-'a')*/
/*			1<<('n'-'a')*/
#define DBG_OPTIONS	1<<('o'-'a')
#define DBG_RDCONF	1<<('p'-'a')
/*			1<<('q'-'a')*/
#define DBG_CVRE	1<<('r'-'a')
#define DBG_CS		1<<('s'-'a')
/*			1<<('t'-'a')*/
#define DBG_HNDOUT	1<<('u'-'a')
/*			1<<('v'-'a')*/
#define DBG_OUTPUT	1<<('w'-'a')
/*			1<<('x'-'a')*/
/*			1<<('y'-'a')*/
#define DBG_NOOUT	1<<('z'-'a')

/*
a  1	f  32	k  1024  p	u	z
b  2	g  64	l  2048  q	v
c  4	h 128	m  4096  r	w
d  8	i 256	n  8192  s	x
e 16	j 512	o 16384  t	y
*/

#define	PR_NEWLINE	1
#define PR_SPCHDRL	2
#define	PR_MSGNUM	4
#define PR_OUTFILE	8
#define	PR_FILESTAT	32
#define	PR_RESTAT	64
#define	PR_STAGE	256
#define	PR_DUPWARN	512
#define	PR_OVFLWARN	1024

#define RE_STYLE_RE	1
#define RE_STYLE_DOS    2
#define RE_STYLE_USER   3

#define PIPEM_FILE	0
#define PIPEM_PIPE	2
#define PIPEM_1		1

#define CLOSE_AT_END	0
#define CLOSE_FFLUSH	1
#define CLOSE_NOW	2

/* extern variables */
#define _EXTERN extern
#include "smextern.h"


/* functions */
#ifdef MSDOS
void	sleep( unsigned ) ;
#endif

ANY_CHAIN * add_to_chain( ANY_CHAIN **, int ) ;
void	add_stmt( int, char * ) ;
int	bldoftab( FILE * ) ;
int	bldrecvt( FILE * ) ;
int	bldretab( FILE * ) ;
int	bldsrttb( FILE * ) ;
int	bldtrtab( FILE * ) ;
void	cfgerror( char * , int ) ;
void	closeany( void ) ;
void    copytail( FILE * ) ;
short	csumm( char * , char * ) ;
void	dbexpire( void ) ;
char *	duptoken( char *, char * ) ;
char *	getcfstr( void ) ;
HLPTR *	hlp_add( char * ) ;
HLPTR *	hlp_find( char * ) ;
int	hdr_in_line( char *, char * ) ;
char *	hdrlfind( char * ) ;
int	hdrl_out( char * ) ;
int	hnd_msg( void ) ;
int	msg_out( OFD * ) ;
int	msgflush( int ) ;
char *	msubst( char *, SR * ) ;
char *	nonblank( char * ) ;
OFD *	oft_add( char *, char *, char * ) ;
OFD *	oft_adds( void ) ;
void	oft_del( OFD * ) ;
OFD *	oft_find(char *);
void	oft_free( OFD * ) ;
void	oft_ins( OFD * ) ;
RE *	re_add( char *, char * );
RE *	re_find( char * );
int	readinpt( void ) ;
void	seterror( int );
int	smanalyz( void ) ;
void	smcloseo( OFD *, int ) ;
void	smclosep( OFD * ) ;
int	smconfig( int, char *[1] ) ;
FILE *	smfcopen( char * ) ;
FILE *	smfopen( char *, char *) ;
FILE *	smfopeno( OFD * ) ;
void *	smmalloc( size_t ) ;
void	smprstat( void ) ;
/*int	smselect( *, *, int ) ;*/
#define	start_of_message(string) regexec(re_StartOfMessage,string)
char *	strd3cat( char *, char * , char * ) ;
#define	strducat(str1,str2) strd3cat(str1,str2,NULL)
#define strdupz(string)	( string ? strdup(string) : NULL )
char *	stredup( char * , char * ) ;
char *	strndup( char * , int ) ;
int	str_out( char * ) ;
char *	strtrans( char * ) ;
int	strtrunc( char * ) ;
char *	subst( char *, char *, char * ) ;

void	fdebug( unsigned long, char *, ... ) ;

#include "smlocalf.h"

/*EOF sortmail.h*/
