/* strfunct.c - additional string functions */
/*
#include <string.h>
#include <stdlib.h>
*/
#include "sortmail.h"

char * nonblank( char * ) ;
char * strndup( char * , int ) ;

#ifndef NULL
#define NULL 0
#endif

/* Returns ptr to 1-st non-blank character in string, or NULL
- like strspn(string," \t") , but returns char* .	*/

char * nonblank(p)
register char * p ;
{
if ( !p ) return(NULL);
while (1) {
switch ( *p ) {
	case 0   :	return(NULL);
	case ' ' :	;
	case '\t':	p++ ; break ;
	default:	return(p) ;
	}
}
return(NULL);/*what for?*/
}


/* Removes \n, \r, \t, ' ' from EOL, returns length of string */
int strtrunc(str)
char * str ;
{
register char * p = strchr(str,'\0');
while ( p > str ) {
	p--;
	if (*p!='\n' && *p!='\r' && *p!=' ' && *p!='\t' ) {
		p++; break; }
	}
*p='\0';
return((int)(p-str));
}


/* strndup */
char * strndup(str,len)
char * str;
int len;
{
char * tmpstr;
int minlen;
if (!str) return(NULL);
minlen=strlen(str);
if (len<minlen) minlen=len;
tmpstr=strncpy((char*)malloc(minlen+1),str,minlen);
*(tmpstr+minlen)='\0';
return(tmpstr);
}


/* stredup */
char * stredup(startp,endp)
char * startp, * endp ;
{
size_t len = endp-startp ;
char * tmpstr ;
if ( !startp || endp<=startp ) return(NULL);
tmpstr=strncpy((char*)malloc(len+1),startp,len);
*(tmpstr+len)='\0';
return(tmpstr);
}


/* strducat returns pointer to string=str1+str2
- like  strdup(strcat(str1,str2)) , but leaves str1 unchanged */
/*
char * strducat(str1,str2)
char * str1, * str2 ;
{
return(
	strcat
		(strcpy(
			malloc( strlen(str1) + strlen(str2) + 1 ) ,
			str1 ) ,
		str2)
		) ;
}
*/

/* strd3cat */
char * strd3cat(str1,str2,str3)
char * str1, * str2, * str3 ;
{
size_t len=1;
char * result;
if ( !str1 && !str2 && !str3 ) return(NULL);

if ( str1 ) len += strlen(str1) ;
if ( str2 ) len += strlen(str2) ;
if ( str3 ) len += strlen(str3) ;

result=(char*)malloc(len);
*result='\0';

if ( str1 ) strcat(result,str1) ;
if ( str2 ) strcat(result,str2) ;
if ( str3 ) strcat(result,str3) ;

return(result);
}

/* duptoken */
char * duptoken(str,dlmcstr)
char * str, * dlmcstr ;
{
char * starttok, * endtok ;
if ( (starttok=nonblank(str)) == NULL ) return NULL ;
if ( (endtok=strpbrk(starttok,dlmcstr)) == NULL ) return(strdup(starttok)) ;
else return(strndup( starttok, (int)(endtok-starttok) )) ;
}


/* strsubst */
char * strsubst(sstr,subslist)
char * sstr;
char * subslist[][2];
{
return(NULL);
}

/******************************/
char* subst(source,search,replace)
char *source, *search, *replace;
{
char *p=source, *p1, *p2 ;
char *dest;
int n_rep=0 ;
int s_len=strlen(search);
int r_len=strlen(replace);
/*printf("SUBST('%s','%s','%s')\n",source,search,replace);*/
while ( (p=strstr(p,search)) != NULL ) { p+=s_len; n_rep++; } ;

dest=(char*)malloc( strlen(source) + 1 + n_rep * (r_len-s_len) ) ;

p1=source; p2=dest;

while ( *p1 ) {
	if ( strncmp(p1,search,s_len ) ) {
		*p2=*p1;
		p2++;
		p1++; }
	else {
		strncpy(p2,replace,r_len) ;
		p2+=r_len;
		p1+=s_len;
		} ;
	} ;
*p2='\0';
return(dest);
}

/***********************/
ANY_CHAIN * add_to_chain(origin,length)
ANY_CHAIN ** origin;
int length;
{
ANY_CHAIN * tmp, * tmp1;
tmp1=(ANY_CHAIN*)malloc(length); tmp1->next=NULL;
if ( *origin ) {
	for(tmp=*origin;tmp->next;tmp=tmp->next); tmp->next=tmp1;}
else *origin=tmp1; return(tmp1);
}

/****/
char *msubst(src_string,subst_origin)
char *src_string;
SR *subst_origin;
{ char *p1=src_string, *p2; SR *re_sr_ptr;
for (re_sr_ptr=subst_origin;re_sr_ptr;re_sr_ptr=re_sr_ptr->next) {
	p2=subst(p1,re_sr_ptr->search,re_sr_ptr->replace);
	if ( p1 != src_string ) free(p1); p1=p2; } ;
	/*if ( debug & 4 ) fprintf(debugout,"Substituted '%s'\n",p2);*/
return(p2);
}

/*EOF strfunct.c */
