#if defined(USE_DBM)

#define xdb_open(name)		dbminit(name)
#define xdb_store(key,content)	store(key,content)
#define xdb_fetch(key)		fetch(key)
#define xdb_delete(key)		delete(key)
#define xdb_firstkey()		firstkey()
#define xdb_nextkey()		nextkey(xdb_prevkey)
#define xdb_close()

#elif defined(USE_NDBM)

#define xdb_open(name)		dbm_open(name,O_RDWR|O_CREAT,0664)
#define xdb_store(key,content)	dbm_store(xdb_file,key,content,DBM_REPLACE)
#define xdb_fetch(key)		dbm_fetch(xdb_file,key)
#define xdb_delete(key)		dbm_delete(xdb_file,key)
#define xdb_firstkey()		dbm_firstkey(xdb_file)
#define xdb_nextkey()		dbm_nextkey(xdb_file)
#define xdb_close()		dbm_close(xdb_file)

#elif defined(USE_GDBM)

#define xdb_open(name)		gdbm_open(name,0,GDBM_WRCREAT,0664,NULL)
#define xdb_store(key,content)	gdbm_store(xdb_file,key,content,GDBM_REPLACE)
#define xdb_fetch(key)		gdbm_fetch(xdb_file,key)
#define xdb_delete(key)		gdbm_delete(xdb_file,key)
#define xdb_firstkey()		gdbm_firstkey(xdb_file)
#define xdb_nextkey()		gdbm_nextkey(xdb_file,xdb_prevkey)
#define xdb_close()	{gdbm_reorganize(xdb_file);gdbm_close(xdb_file);}

#endif

/*
S  int dbminit ( name )
N  DBM *dbm_open (name, flags, mode)
G  GDBM_FILE gdbm_open ( name, block_size, read_write, mode, fatal_func )

S  int store ( key, content )
N  int dbm_store (file, key, content, flags)
G  int gdbm_store ( dbf, key, content, flags )

S  datum fetch ( key )
N  datum dbm_fetch (file, key)
G  datum gdbm_fetch ( dbf, key )

S  int delete ( key )
N  int dbm_delete (file, key)
G  int gdbm_delete ( dbf, key )

S  datum firstkey ()
N  datum dbm_firstkey (file)
G  datum gdbm_firstkey ( dbf )

S  datum nextkey ( key )
N  datum dbm_nextkey (file)
G  datum gdbm_nextkey ( dbf, key )


G  void gdbm_close ( dbf )
N  void dbm_close (file)


G  int gdbm_reorganize ( dbf )

N  int dbm_error (file)

N  int dbm_clearerr (file)
*/
